题目链接:这里
Mahmoud wrote a message s of length n. He wants to send it as a birthday present to his friend Moaz who likes strings. He wrote it on a magical paper but he was surprised because some characters disappeared while writing the string. That’s because this magical paper doesn’t allow character number i in the English alphabet to be written on it in a string of length more than ai. For example, if a1 = 2 he can’t write character ‘a’ on this paper in a string of length 3 or more. String “aa” is allowed while string “aaa” is not.

Mahmoud decided to split the message into some non-empty substrings so that he can write every substring on an independent magical paper and fulfill the condition. The sum of their lengths should be n and they shouldn’t overlap. For example, if a1 = 2 and he wants to send string “aaa”, he can split it into “a” and “aa” and use 2 magical papers, or into “a”, “a” and “a” and use 3 magical papers. He can’t split it into “aa” and “aa” because the sum of their lengths is greater than n. He can split the message into single string if it fulfills the conditions.

A substring of string s is a string that consists of some consecutive characters from string s, strings “ab”, “abc” and “b” are substrings of string “abc”, while strings “acb” and “ac” are not. Any string is a substring of itself.

While Mahmoud was thinking of how to split the message, Ehab told him that there are many ways to split it. After that Mahmoud asked you three questions:

How many ways are there to split the string into substrings such that every substring fulfills the condition of the magical paper, the sum of their lengths is n and they don't overlap? Compute the answer modulo 109 + 7.
What is the maximum length of a substring that can appear in some valid splitting?
What is the minimum number of substrings the message can be spit in? 

Two ways are considered different, if the sets of split positions differ. For example, splitting “aa|a” and “a|aa” are considered different splittings of message “aaa”.
Input

The first line contains an integer n (1 ≤ n ≤ 103) denoting the length of the message.

The second line contains the message s of length n that consists of lowercase English letters.

The third line contains 26 integers a1, a2, …, a26 (1 ≤ ax ≤ 103) — the maximum lengths of substring each letter can appear in.
Output

Print three lines.

In the first line print the number of ways to split the message into substrings and fulfill the conditions mentioned in the problem modulo 109  +  7.

In the second line print the length of the longest substring over all the ways.

In the third line print the minimum number of substrings over all the ways.
Examples
Input

3
aab
2 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1

Output

3
2
2

Input

10
abcdeabcde
5 5 5 5 4 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1

Output

401
4
3

题意:

给你一个长度为n的串,然后再给你26个数num[i]。

你现在要分割这个串,合法的分割是:如果某一个分割存在字母i,那么要么满足len<=num[i]才行,就是这个分割的长度应该小于num[i]

然后让你输出:

(1)分割的方式数量 mod 1e9+7

(2)合法的分割中,最长的分割长度是多少?

(3)最少的分割次数是多少?

解法:
设f[i]表示从i开始进行分割的方案数;
f[i] += ∑f[j];这里min(ma[s[i]..s[j]])>=j-i+1,且j>=i;
ma[x]是x这个字母能够待在的最长的字符串的长度;
然后每次都用j-i+1尝试更新“段”的最大值;
用一个num[i]表示以i作为分割的起点需要分成几段;
num[i]=min(num[i],num[j]+1);
边界:
f[n+1]=1,num[n+1]=0;
逆序更新;
最后输出f[1]就好;

//HDU 4388

#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e3+7;
const long long mod = 1e9+7;
int n, maxseg, a[maxn], ma[maxn], num[maxn];//num[i]表示以i作为分割的起点,需要分成几段,maxseg表示合法的分割中,最长的分割长度是多少
long long dp[maxn]; //dp[i]代表从i开始分割的方案数
char s[maxn];
int main()
{
    memset(dp, -1, sizeof(dp));
    memset(num, 0x3f, sizeof(num));
    scanf("%d", &n);
    scanf("%s", s+1);
    for(int i = 1; i <= n; i++){
        a[i] = s[i] - 'a' + 1;
    }
    for(int i = 1; i <= 26; i++) scanf("%d", &ma[i]);
    maxseg = 0;
    dp[n+1] = 1LL, num[n+1] = 0;
    for(int i = n; i >= 1; i--){
        int minseg = 1e8;
        for(int j = i; j <= n; j++){
            minseg = min(minseg, ma[a[j]]);
            int curseg = j - i + 1;//当前段大小
            if(curseg > minseg) break;
            if(dp[j+1] != -1){
                if(dp[i] == -1) dp[i] = 0;
                dp[i] = (dp[i] + dp[j+1]) % mod;
                num[i] = min(num[i], num[j+1]+1);
                maxseg = max(maxseg, curseg);
            }
        }
    }
    cout << dp[1] << endl;
    cout << maxseg << endl;
    cout << num[1] << endl;
    return 0;
}